/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef AQSERVICEERROR_H_2373802858__H_
#define AQSERVICEERROR_H_2373802858__H_


#include <boost/any.hpp>
#include <avro/Specific.hh>
#include <avro/Encoder.hh>
#include <avro/Decoder.hh>
struct AQServiceError {
    std::string serviceName;
    std::string errorType;
    std::string message;
    std::string details;
};

namespace avro {
template<> struct codec_traits<AQServiceError> {
    static void encode(Encoder& e, const AQServiceError& v) {
        avro::encode(e, v.serviceName);
        avro::encode(e, v.errorType);
        avro::encode(e, v.message);
        avro::encode(e, v.details);
    }
    static void decode(Decoder& d, AQServiceError& v) {
        avro::decode(d, v.serviceName);
        avro::decode(d, v.errorType);
        avro::decode(d, v.message);
        avro::decode(d, v.details);
    }
};

}
#endif
