#ifndef SPEECH_ENGINE_H_
#define SPEECH_ENGINE_H_

#include <string.h>
#include "robokind/messaging/AQSender.h"

namespace robokind {
  namespace speech { 

	class SpeechEngine {
		public:
			virtual bool initialize(std::string voiceName, double sampleRate, AQSender* eventSender) = 0;
			virtual bool isInitialized() = 0;
			virtual void stop() = 0;

			virtual unsigned long speak(const std::string& phrase) = 0;
			virtual unsigned long cancelSpeech() = 0;

			virtual void startEventListener() = 0;
			virtual bool isListening() = 0;
			virtual void stopEventListener() = 0;
	};
}}
#endif