#ifndef SAPI_ENGINE_H_
#define SAPI_ENGINE_H_

#include <sapi.h>
#include <windows.h>
#include "sphelper.h"
#include <string>
#include "robokind/speech/SpeechEngine.h"
#include "SAPIEventListener.h"

namespace robokind {
  namespace speech { 

		class SAPIEngine : public SpeechEngine {
		public:
			SAPIEngine();
			~SAPIEngine();

			static SAPIEngine* instance();
			
			bool initialize(std::string voiceName, double sampleRate, AQSender* eventSender);
			bool isInitialized();
			void stop();

			unsigned long speak(const std::string& phrase);
			unsigned long cancelSpeech();

			void startEventListener();
			bool isListening();
			void stopEventListener();

		private:
			HANDLE m_eventListen[3];
			ISpVoice* m_voice;
			SAPIEventListener* m_listener;
			bool m_initialized;
			bool m_listening;
	};
	static SAPIEngine* s_SAPIEngineInstance;
}}
#endif