/* 
 * File:   FaceDetectService.h
 * Author: matt
 *
 * Created on July 15, 2011, 8:40 PM
 */

#ifndef FACEDETECTSERVICE_H
#define	FACEDETECTSERVICE_H


#include <sys/time.h>
#include <stdio.h>
#include <opencv/cv.h>
#include <opencv/cxcore.h>
#include <opencv/highgui.h>
#include <cstdlib>
#include <vector>
#include <qpid/messaging/Message.h>
#include "string.h"

#include "robokind/messaging/AQService.h"
#include "robokind/vision/protocol/ImageRecord.h"
#include "robokind/messaging/AQReceiver.h"
#include "robokind/messaging/AQSender.h"
#include "robokind/messaging/AQStream.h"
#include "robokind/vision/proc/facedetect/FaceDetector.h"
#include "robokind/vision/proc/facedetect/protocol/FaceDetectConfig.h"


using namespace std;
using namespace qpid::messaging;

namespace robokind{
    class FaceDetectService : public AQService<FaceDetectConfig>{
        private:
			AQStream* myStream;
            AQReceiver* myImageReceiver;
            AQSender* myResultsSender;
            FaceDetector* myFaceDetector;
			FaceDetectConfig* myConfig;
            
            void threadSafeWorker();
            bool _initialize(FaceDetectConfig* conf);
            void close();

        public:
			virtual void _start();
            void handleCommandMessage(Message &msg);
    };
}

#endif	/* FACEDETECTSERVICE_H */

